/*
   -
   - The contents of this file are subject to the Mozilla Public License
   - Version 1.1 (the "License"); you may not use this file except in
   - compliance with the License. You may obtain a copy of the License at
   - http://www.mozilla.org/MPL/ 
   - 
   - Software distributed under the License is distributed on an "AS IS" basis,
   - WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   - for the specific language governing rights and limitations under the
   - License. 
   -
   - The Original Code is Bugxula
   - 
   - The Initial Developer of the Original Code is
   - Netscape Communications Corporation
   - Portions created by Netscape are
   - Copyright (C) 1998 Netscape Communications Corporation.
   - All Rights Reserved.
   -
   - Alternatively, the contents of this file may be used under the
   - terms of the GNU Public License (the "GPL"), in which case the
   - provisions of the GPL are applicable instead of those above.
   - If you wish to allow use of your version of this file only
   - under the terms of the GPL and not to allow others to use your
   - version of this file under the MPL, indicate your decision by
   - deleting the provisions above and replace them with the notice
   - and other provisions required by the GPL.  If you do not delete
   - the provisions above, a recipient may use your version of this
   - file under either the MPL or the GPL.
   -
   - Contributor(s):
   -  
   - Myk Melez, myk@mozilla.org, original author
   - 
*/

var gDefaultColumnSettings = {};
var gAppConfigDS;
var gMyPrefs;
var appCore = null;
var myBrowser;

function onLoad()
{  
  gMyPrefs = new PrefsWrapper1('extensions.bugxula.'); 
  var installation_url = gMyPrefs.getUnicharPref('installation1.url');
  var installation_name = gMyPrefs.getUnicharPref('installation1.name');
  var installation_icon = gMyPrefs.getUnicharPref('installation1.icon');
  var new_search_installation = document.createElement('menuitem');
  new_search_installation.setAttribute('type','checkbox');
  new_search_installation.setAttribute('src',installation_icon);
  new_search_installation.setAttribute('label',installation_name);
  new_search_installation.setAttribute('oncommand',"setActiveInstallation('"+installation_url+"','"+installation_icon+"')");
  document.getElementById('bugxula-zilla-list').appendChild(new_search_installation);
  document.getElementById('mnToolsNewBug1').label = document.getElementById('mnToolsNewBug1').label + installation_name;
  document.getElementById('mnToolsNewBug1').oncommand = "menu_SetActiveInstallation('" + installation_url + "','" + installation_icon + "');";
  
  // Should use setActiveInstallation function, but for some reason that fails silently and 
  // prevents execution of the rest of this function.
  gActiveInstallation = installation_url;
  //setActiveInstallation(installation_url,installation_icon);
  //document.getElementById('searchbar-dropmarker').setAttribute('src',installation_icon);
  
  var installation_url = gMyPrefs.getUnicharPref('installation2.url');
  var installation_name = gMyPrefs.getUnicharPref('installation2.name');
  var installation_icon = gMyPrefs.getUnicharPref('installation2.icon');
  new_search_installation = document.createElement('menuitem');
  new_search_installation.setAttribute('type','checkbox');
  new_search_installation.setAttribute('src',installation_icon);
  new_search_installation.setAttribute('label',installation_name);
  new_search_installation.setAttribute('oncommand',"setActiveInstallation('"+installation_url+"','"+installation_icon+"')");
  document.getElementById('bugxula-zilla-list').appendChild(new_search_installation);
  document.getElementById('mnToolsNewBug2').label = document.getElementById('mnToolsNewBug2').label + installation_name;
   
  installation_url = gMyPrefs.getUnicharPref('installation3.url');
  installation_name = gMyPrefs.getUnicharPref('installation3.name');
  installation_icon = gMyPrefs.getUnicharPref('installation3.icon');
  new_search_installation = document.createElement('menuitem');
  new_search_installation.setAttribute('type','checkbox');
  new_search_installation.setAttribute('src',installation_icon);
  new_search_installation.setAttribute('label',installation_name);
  new_search_installation.setAttribute('oncommand',"setActiveInstallation('"+installation_url+"','"+installation_icon+"')");
  document.getElementById('bugxula-zilla-list').appendChild(new_search_installation);
  document.getElementById('mnToolsNewBug3').label = document.getElementById('mnToolsNewBug3').label + installation_name;
  
  installation_url = gMyPrefs.getUnicharPref('installation4.url');
  installation_name = gMyPrefs.getUnicharPref('installation4.name');
  installation_icon = gMyPrefs.getUnicharPref('installation4.icon');
  new_search_installation = document.createElement('menuitem');
  new_search_installation.setAttribute('type','checkbox');
  new_search_installation.setAttribute('src',installation_icon);
  new_search_installation.setAttribute('label',installation_name);
  new_search_installation.setAttribute('oncommand',"setActiveInstallation('"+installation_url+"','"+installation_icon+"')");
  document.getElementById('bugxula-zilla-list').appendChild(new_search_installation);
  document.getElementById('mnToolsNewBug4').label = document.getElementById('mnToolsNewBug4').label + installation_name;
  
  installation_url = gMyPrefs.getUnicharPref('installation5.url');
  installation_name = gMyPrefs.getUnicharPref('installation5.name');
  installation_icon = gMyPrefs.getUnicharPref('installation5.icon');
  new_search_installation = document.createElement('menuitem');
  new_search_installation.setAttribute('type','checkbox');
  new_search_installation.setAttribute('src',installation_icon);
  new_search_installation.setAttribute('label',installation_name);
  new_search_installation.setAttribute('oncommand',"setActiveInstallation('"+installation_url+"','"+installation_icon+"')");
  document.getElementById('bugxula-zilla-list').appendChild(new_search_installation);
  document.getElementById('mnToolsNewBug5').label = document.getElementById('mnToolsNewBug5').label + installation_name;
/*
  appCore = Components.classes["@mozilla.org/appshell/component/browser/instance;1"]
          .createInstance(Components.interfaces.nsIBrowserInstance);
  appCore.setWebShellWindow(window);
  myBrowser = document.getElementById("content-tabbrowser");

  const nsIWebNavigation = Components.interfaces.nsIWebNavigation;
  myBrowser.webNavigation.loadURI("http://www.mozdev.org", 
          nsIWebNavigation.LOAD_FLAGS_NONE, null, null, null);*/
  //This doesn't do anything, but I'm not sure why.
  document.getElementById('content-tabbrowser').loadURI('chrome://bugxula/content/welcome.html');

  // Save the current column settings as the default.
  // This way we can reset them to the default when deactivating
  // a search or when activating an unsaved search.
  gDefaultColumnSettings = getColumnSettings();
}

var data_url;
function runQuickSearch() {
	var search_term = document.getElementById('search-term').value;
	
	if (search_term == '') {
		// Ignore blank searches
	}
	else if (isInt(search_term)) {
		document.getElementById('content-tabbrowser').loadURI(gActiveInstallation + 'show_bug.cgi?id=' + search_term);
	}
	else {	
		var data_url = gActiveInstallation + 'buglist.cgi?query_format=advanced&format=rdf&content=' + search_term;
		document.getElementById('content-tabbrowser').loadURI('chrome://bugxula/content/results.xul?'+data_url);
	}
}

function runTestSearch() {
	document.getElementById('search-term').value='PNG crash';
	runQuickSearch();
}


function saveSearch()
{
  var name = prompt("Please enter a name for the search:");
  
  // Cancel without doing anything if the user clicked the "Cancel" button.
  if (name == undefined) return;
  
  // For some reason the user didn't enter a name but still wants to save
  // the search.  Assume they know what they are doing and assign the search
  // a default name.
  if (name == "") name = "unnamed search";

  // Generate a unique URI for this query.
  // !!! Figure out how to assign an RDF type to the resource so it looks like
  // <bz:query...> in the data source instead of <RDF:Description...>!
  var queryURI = gUserDS.generateUniqueURI();
  
  // Add the query to the user's list of queries.
  var queries = gUserDS.getContainer("urn:bugxula:root", "bz:queries");
  queries.appendResource(queryURI);
  
  // Create a list of installations for the query and add the query's installation to it.
  var installations = gUserDS.makeBag(queryURI, "bz:installations");
  for ( var i=0 ; i<gActiveSearch.installations.length ; i++ )
    installations.appendResource(gActiveSearch.installations[i]);

  // Add the search conditions and give the query a name.
  gUserDS.assertLiteral(queryURI, "bz:conditions", gActiveSearch.conditions);
  gUserDS.assertLiteral(queryURI, "bz:name", name);
  
  activateSearch(queryURI);

  // Save the user's data source to disk to make sure we don't lose this query
  // if Mozilla crashes.
  gUserDS.flush();
}

function editSearch()
{
  alert("Sorry, this feature isn't implemented yet.");
}

function refreshSearch()
{
  var results = getActiveResults();
  var resultURI, ds;
  while (results.hasMoreElements())
  {
    resultURI = results.getNextElement();
    ds = RDFDataSource.get(resultURI);
    if (ds)
    {
      gActiveSearch.state = "loading";
      incrementProgressMeter();
      ds.refresh();
    }
  }
  updateSearchOptions();
}

function deleteSearch()
{
  // Remove the installations list from the search resource and the data source.
  var installations = gUserDS.getContainer(gActiveSearch.uri, 'bz:installations');
  installations.purge();
  
  // Remove the conditions from the search resource.
  var conditions = gUserDS.getTarget(gActiveSearch.uri, 'bz:conditions');
  gUserDS.unassertResource(gActiveSearch.uri, 'bz:conditions', conditions);

  // Remove the search resource from the list of searches.
  var searches = gUserDS.getContainer("urn:bugxula:root", 'bz:queries');
  searches.removeResource(gActiveSearch.uri);

  // Unload the query's results from the results pane.
  deactivateSearch();

  // Rebuild the search pane so the entry for this search disappears.
  document.getElementById('searches-tree').builder.rebuild();
}


function handleContentAreaClick(event)
{
  // Adapted from contentAreaClick() in
  // mozilla/xpfe/communicator/resources/content/contentAreaClick.js.
  
  // That function handles all kinds of clicks except for left-clicks on links, 
  // which it passes back to the browser widget to handle by just returning 
  // "true" in those situations.
  
  // I wish I could use that function instead of rolling my own, but I need 
  // to open left-clicked links in a browser window rather than allowing 
  // the browser widget embedded in this application to handle them.
  // The embedded browser widget shouldn't be handling these links anyway
  // (the one in messenger.xul doesn't handle them), but I can't figure out
  // how to make that happen.
  
  // So, instead I use some code from that function to call handleLinkClick() 
  // (from the same file) on the appropriate URL and note that function's 
  // return value.  If it returns false, meaning it did not handle the link,
  // I handle it myself by opening it in a browser window (creating
  // a new one if necessary) using code I adapted from 
  // mozilla/xpfe/components/search/resources/search-panel.js.

  var target = event.target;
  var linkNode;
  
  var local_name = target.localName;
 
  if (local_name) {
    local_name = local_name.toLowerCase();
  }

  switch (local_name) {
    case "a":
    case "area":
    case "link":
      if (target.hasAttribute("href")) 
        linkNode = target;
      break;
    default:
      linkNode = findParentNode(event.originalTarget, "a");
      // <a> cannot be nested.  So if we find an anchor without an
      // href, there is no useful <a> around the target
      if (linkNode && !linkNode.hasAttribute("href"))
        linkNode = null;
      break;
  }
  if (linkNode) 
  {
    var handled = handleLinkClick(event, linkNode.href);
    if (!handled) loadURLInBrowser(linkNode.href);
  } 
  else 
  {
    // The user did not click on a link, so let the click event continue
    // in case some other handler needs to do something with it.
    return true;
  }

  return false;
}

function stopRun()
{
  // Stops the search currently being run.
  
  // Get a list of active results being loaded.
  var results = getActiveResults();  
  var resultURI, ds;
  while (results.hasMoreElements())
  {
    resultURI = results.getNextElement();
    ds = RDFDataSource.get(resultURI);
    if (ds) ds.cancelLoad();
  }
  
  deactivateSearch();
}
